#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "volterra.h"
#include "volterra_eval.h"

int main(int argc, char *argv[])
{

  int Pmin, Pmax, Mmin, Mmax, N=100, R=-100e6, P, M;
  
  FILE *fp;

  if (argc == 1) {
    Pmin = 1;
    Pmax = 12;
    Mmin = 2;
    Mmax = 2;    
  } else if (argc == 5) {
    Pmin = atoi(argv[1]);
    Pmax = atoi(argv[2]);
    Mmin = atoi(argv[3]);
    Mmax = atoi(argv[4]);            
  } else {
    fprintf(stderr, "There must be either zero or four input arguments (Pmin Pmax Mmin Mmax).\n");
  }

  volterraEvalInit(Pmax,Mmax,N);
  
  volterraEvalPrintRuntimeHeader(Pmin,Pmax,Mmin,Mmax);
  
  fp = fopen("runtime.txt","w");
  for (P=Pmin; P<=Pmax; P++) {
    for (M=Mmin; M<=Mmax; M++) {    
      volterraEvalRun(P,M,N,R);
      volterraEvalPrintRuntime(P,M);
      volterraEvalStoreRuntime(P,M,fp);
    }
  }  
  fclose(fp);
  
  printf("\nFile runtime.txt was produced.\n");
  
  getchar();
  return 0;
  
}
