#include <stdio.h>
#include <stdlib.h>

#include "volterra.h"

int binomial(int n, int k) {
  if (n==k || n==1 || k==0) {
    return 1;
  } else {
    return (binomial(n-1,k-1)+binomial(n-1,k));
  }
}

void volterraSize(int P, int M, int *C) {
  int p;
  C[0] = 0;
  for (p=1; p<=P; p++) {
    C[p] = C[p-1] + binomial(M+p,p);
  }
}

void volterraTable(int *tab, int P, int M, int *m) {
  int i, j, p, pp;
  for (i=0; i<=M; i++) {
    tab[1] = i;
    tab += P+1;
  }
  j = 0;
  for (p=2; p<=P; p++) {
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }    
    start:
    tab[0] = j;
    for (pp=1; pp<=p; pp++) {
      tab[pp] = m[pp];
    }      
    tab += P+1;    
    i++;
    if (m[p] < M) {
      m[p]++;
      goto start;
    }
    j++;
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
  }
}

void volterraTablePrint(int *tab, int P, int *C) {
  int i, p, pp;
  printf("   i   j");
  for (pp=1; pp<=P; pp++) {    
    printf("  m%d", pp);
  }
  printf("\n");
  for (p=1; p<=P; p++) {
    for (i=C[p-1]; i<C[p]; i++) {
      printf(" %3d", i);
      if (p == 1)
        printf("   -");      
      else
        printf(" %3d", tab[0]);
      for (pp=1; pp<=p; pp++)
        printf(" %3d", tab[pp]);
      for (; pp<=P; pp++)
        printf("   -");
      printf("\n");
      tab += P+1;
    }
  }
}
