#ifndef INCLUDE_VOLTERRA
#define INCLUDE_VOLTERRA

typedef double smp;

// volterra.c
int  binomial(int n, int k);
void volterraSize(int P, int M, int *C);
void volterraTable(int *tab, int P, int M, int *m);
void volterraTablePrint(int *tab, int P, int *C);

// volterra_direct1.c
void volterraFilterDirect1Comb(smp *x, smp *y, smp *h, int P, int M, smp *xx, int *m);
void volterraFilterDirect1Table(smp *x, smp *y, smp *h, int P, int *C, smp *xx, int *tab);
void volterraGenerateDirect1Loop(int P);
void volterraGenerateDirect1Hard(int P, int M, int *C, int *m);

// volterra_direct1.c - generated
void volterraFilterDirect1Loop(smp *x, smp *y, smp *h, int P, int M, smp *xx);
void volterraFilterDirect1HardMem0(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem1(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem2(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem3(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem4(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem5(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem6(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem7(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem8(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem9(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem10(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterDirect1HardMem11(smp *x, smp *y, smp *h, int P, smp *xx);

// volterra_direct2.c
void volterraFilterDirect2Comb(smp *x, smp *y, smp *h, int P, int M, int *m);
void volterraFilterDirect2Table(smp *x, smp *y, smp *h, int P, int *C, int *tab);
void volterraGenerateDirect2Loop(int P);
void volterraGenerateDirect2Hard(int P, int M, int *m);

// volterra_direct2.c - generated
void volterraFilterDirect2Loop(smp *x, smp *y, smp *h, int P, int M);
void volterraFilterDirect2HardMem0(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem1(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem2(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem3(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem4(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem5(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem6(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem7(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem8(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem9(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem10(smp *x, smp *y, smp *h, int P);
void volterraFilterDirect2HardMem11(smp *x, smp *y, smp *h, int P);

// volterra_reuse.c
void volterraFilterReuseComb(smp *x, smp *y, smp *h, int P, int M, smp *xx, int *m);
void volterraFilterReuseTable(smp *x, smp *y, smp *h, int P, int M, int *C, smp *xx, int *tab);
void volterraGenerateReuseLoop(int P);
void volterraGenerateReuseHard(int P, int M, int *C, int *m);

// volterra_reuse.c - generated
void volterraFilterReuseLoop(smp *x, smp *y, smp *h, int P, int M, smp *xx);
void volterraFilterReuseHardMem0(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem1(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem2(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem3(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem4(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem5(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem6(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem7(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem8(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem9(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem10(smp *x, smp *y, smp *h, int P, smp *xx);
void volterraFilterReuseHardMem11(smp *x, smp *y, smp *h, int P, smp *xx);

// volterra_horner.c
void volterraFilterHornerComb(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g, int *m);
void volterraFilterHornerTable(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g, int *tab);
void volterraGenerateHornerLoop(int P);
void volterraGenerateHornerHard(int P, int M, int *C, int *m);

// volterra_horner.c - generated
void volterraFilterHornerLoop(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g);
void volterraFilterHornerHardMem0(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem1(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem2(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem3(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem4(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem5(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem6(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem7(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem8(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem9(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem10(smp *x, smp *y, smp *h, int P, smp *g);
void volterraFilterHornerHardMem11(smp *x, smp *y, smp *h, int P, smp *g);

#endif
