#include <stdio.h>
#include "volterra.h"

void volterraFilterDirect1Comb(smp *x, smp *y, smp *h, int P, int M, smp *xx, int *m) {
  int i=0, p, pp;
  *y = 0;
  for (p=1; p<=P; p++) {
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }
    start:
    xx[i] = x[-m[1]];
    for (pp=2; pp<=p; pp++) {
      xx[i] *= x[-m[pp]];
    }
    *y += h[i] * xx[i];
    i++;
    if (m[p] < M) {
      m[p]++;
      goto start;
    }
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
  }
}

void volterraFilterDirect1Table(smp *x, smp *y, smp *h, int P, int *C, smp *xx, int *tab) {
  int i=0, p, pp;
  *y = 0;
  for (p=1; p<=P; p++) {
    while (i < C[p]) {
      xx[i] = x[-tab[1]];
      for (pp=2; pp<=p; pp++)
        xx[i] *= x[-tab[pp]];
      *y += h[i++] * xx[i];
      tab += P+1;
    }
  }
}

void volterraGenerateDirect1Loop(int P) {
  int i, p, pp, ppp;
  FILE *fp = fopen("volterra_direct1_loop.c", "w");
  fprintf(fp, "// This file was generated by volterraGenerateDirect1Loop() in volterra_direct1.c\n\n");  
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterDirect1Loop(smp *x, smp *y, smp *h, int P, int M, smp *xx) {\n");
  fprintf(fp, "  int i=0");
  for (p=1; p<=P; p++) fprintf(fp, ", m%d", p);
  fprintf(fp, ";\n");
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterDirect1Loop().\\n\");\n", P);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");
  fprintf(fp, "  *y = 0;\n");  
  for (p=1; p<=P; p++) {
    fprintf(fp, "  for(m1=0; m1<=M; m1++) {\n");
    for (pp=2; pp<=p; pp++) {
      for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
      fprintf(fp, "for(m%d=m%d; m%d<=M; m%d++) {\n", pp, pp-1, pp, pp);
    }
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
    fprintf(fp, "xx[i] = x[-m1]");  
    for (pp=2; pp<=p; pp++) fprintf(fp, " * x[-m%d]", pp);
    fprintf(fp, ";\n");    
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");    
    fprintf(fp, "*y += h[i] * xx[i];\n");
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");    
    fprintf(fp, "i++;\n");
    for (pp=p; pp>=2; pp--) {
      for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
      fprintf(fp, "}\n");
    }        
    fprintf(fp, "  }\n");    
    if (p < P) fprintf(fp, "  if (P == %d) return;\n", p);
  }  
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File volterra_direct1_loop.c was generated.\n");
}

void volterraGenerateDirect1Hard(int P, int M, int *C, int *m) {
  int i=0, p, pp;
  char filename[40];
  sprintf(filename, "volterra_direct1_hard_mem%d.c", M);
  FILE *fp = fopen(filename, "w");
  fprintf(fp, "// This file was generated by volterraGenerateDirect1Hard() in volterra_direct1.c\n\n");      
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterDirect1HardMem%d(smp *x, smp *y, smp *h, int P, smp *xx) {\n", M);
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterDirect1HardMem%d().\\n\");\n", P, M);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");
  for (p=1; p<=P; p++) {
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }
    start:
    fprintf(fp, "  xx[%d] = x[%d]", i, -m[1]);
    for (pp=2; pp<=p; pp++) {
      fprintf(fp, " * x[%d]", -m[pp]);
    }
    fprintf(fp, ";\n");
    i++;
    if (m[p] < M) {
      m[p]++;
      goto start;
    }
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
    if (p < P) {
      fprintf(fp, "  if (P == %d) goto mult;\n", p);
    }    
  }
  fprintf(fp, "  mult:\n");  
  fprintf(fp, "  *y = 0;\n");
  i = 0;
  for (p=1; p<=P; p++) {
    while (i < C[p]) {
      fprintf(fp, "  *y += h[%d] * xx[%d];\n", i, i);
      i++;
    }
    if (p < P) {
      fprintf(fp, "  if (P == %d) return;\n", p);
    }    
  }  
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File %s was generated.\n", filename);
}
