#include <stdio.h>
#include "volterra.h"

void volterraFilterHornerComb(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g, int *m) {
  int i, j, p, pp;
  smp *gg = h;
  for (p=P; p>1; p--) {
    i = C[p-1];
    j = C[p-2];    
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }
    start:
    g[j] = h[j];
    next:
    g[j] += x[-m[p]] * gg[i];      
    i++;
    if (m[p] < M) {
      m[p]++;
      goto next;
    }
    j++;
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
    gg = g;
  }
  *y = 0;
  for (i=0; i<=M; i++) {
    *y += g[i] * x[-i];
  }
}

void volterraFilterHornerTable(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g, int *tab) {
  int i, p, *m, m0;
  smp *gg = h;  
  for (p=P; p>1; p--) {
    i = C[p-1];
    m = tab + C[p-1]*(P+1);    
    while (i < C[p]) {
      m0 = m[0];
      g[m0] = h[m0] + x[-m[p]] * gg[i++];
      m += P+1;
      while (m[0] == m0) {
        g[m0] += x[-m[p]] * gg[i++];
        m += P+1;
      }
    }
    gg = g;
  }    
  *y = 0;
  for (i=0; i<=M; i++) {
    *y += g[i] * x[-i];
  }
}
  
void volterraGenerateHornerLoop(int P) {
  int p, pp, ppp;
  FILE *fp = fopen("volterra_horner_loop.c", "w");
  fprintf(fp, "// This file was generated by volterraGenerateHornerLoop() in volterra_horner.c\n\n");  
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterHornerLoop(smp *x, smp *y, smp *h, int P, int M, int *C, smp *g) {\n");
  fprintf(fp, "  int i, m0");
  for (p=1; p<=P; p++) fprintf(fp, ", m%d", p);
  fprintf(fp, ";\n");
  fprintf(fp, "  smp *gg = h;\n");  
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterHornerLoop().\\n\");\n", P);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");
  fprintf(fp, "  switch (P) {\n");
  for (p=P; p>=1; p--) {
    fprintf(fp, "    case %d: goto P%d;\n", p, p);    
  }
  fprintf(fp, "  }\n");  
  for (p=P; p>1; p--) {
    fprintf(fp, "  P%d:\n", p);
    fprintf(fp, "  m0 = C[%d];\n", p-2);
    fprintf(fp, "  i  = C[%d];\n", p-1);
    fprintf(fp, "  for(m1=0; m1<=M; m1++) {\n");
    for (pp=2; pp<=p; pp++) {
      if (pp == p) {
        for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
        fprintf(fp, "g[m0] = h[m0] + gg[i++] * x[-m%d];\n", p-1);        
        for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
        fprintf(fp, "for(m%d=m%d+1; m%d<=M; m%d++) {\n", pp, pp-1, pp, pp);                
      } else {
        for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
        fprintf(fp, "for(m%d=m%d; m%d<=M; m%d++) {\n", pp, pp-1, pp, pp);        
      }
    }
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
    fprintf(fp, "g[m0] += gg[i++] * x[-m%d];\n", p);    
    for (pp=p; pp>=2; pp--) {
      for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
      fprintf(fp, "}\n");
      if (pp == p) {
        for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
        fprintf(fp, "m0++;\n");        
      }      
    }        
    fprintf(fp, "  }\n");    
    fprintf(fp, "  gg = g;\n");
  }
  fprintf(fp, "  P1:\n");
  fprintf(fp, "  *y = 0;\n");
  fprintf(fp, "  for (m1=0; m1<=M; m1++) {\n");
  fprintf(fp, "    *y += gg[m1] * x[-m1];\n");
  fprintf(fp, "  }\n");  
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File volterra_horner_loop.c was generated.\n");
}  

void volterraGenerateHornerHard(int P, int M, int *C, int *m) {
  int i, j, p, pp;
  char filename[40];
  sprintf(filename, "volterra_horner_hard_mem%d.c", M);
  FILE *fp = fopen(filename, "w");  
  fprintf(fp, "// This file was generated by volterraGenerateHornerHard() in volterra_horner.c\n\n");      
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterHornerHardMem%d(smp *x, smp *y, smp *h, int P, smp *g) {\n", M);
  fprintf(fp, "  smp *gg = h;\n");
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterHornerHardMem%d().\\n\");\n", P, M);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");
  fprintf(fp, "  switch (P) {\n");
  for (p=P; p>=1; p--) {
    fprintf(fp, "    case %d: goto P%d;\n", p, p);    
  }
  fprintf(fp, "  }\n");    
  for (p=P; p>1; p--) {
    fprintf(fp, "  P%d:\n", p);    
    i = C[p-1];
    j = C[p-2];    
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }
    start:
    fprintf(fp, "  g[%d] = h[%d]", j, j);
    next:
    fprintf(fp, " + x[%d] * gg[%d]", -m[p], i);
    i++;
    if (m[p] < M) {
      m[p]++;
      goto next;
    }
    fprintf(fp, ";\n");
    j++;
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
    fprintf(fp, "  gg = g;\n");
  }  
  fprintf(fp, "  P1:\n");  
  fprintf(fp, "  *y = 0;\n");
  for (i=0; i<=M; i++) {
    fprintf(fp, "  *y += gg[%d] * x[%d];\n", i, -i);
  }
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File %s was generated.\n", filename);
}
