#include <stdio.h>
#include "volterra.h"

void volterraFilterReuseComb(smp *x, smp *y, smp *h, int P, int M, smp *xx, int *m) {
  int i, j, p, pp;
  *y = 0;
  for (i=0; i<=M; i++) {
    xx[i] = x[-i];
    *y += h[i] * xx[i];
  }
  j = 0;
  for (p=2; p<=P; p++) {
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }    
    start:
    xx[i] = xx[j] * x[-m[p]];
    *y += h[i] * xx[i];
    i++;
    if (m[p] < M) {
      m[p]++;
      goto start;
    }
    j++;
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
  }
}

void volterraFilterReuseTable(smp *x, smp *y, smp *h, int P, int M, int *C, smp *xx, int *tab) {
  int i, p, pp;
  *y = 0;
  for (i=0; i<=M; i++) {
    xx[i] = x[-i];
    *y += h[i] * xx[i];
  }
  tab += (P+1)*C[1];
  for (p=2; p<=P; p++) {
    while (i < C[p]) {
      xx[i] = xx[tab[0]] * x[-tab[p]];
      *y += h[i] * xx[i++];
      tab += P+1;
    }
  }  
}
        
void volterraGenerateReuseLoop(int P) {
  int p, pp, ppp;
  FILE *fp = fopen("volterra_reuse_loop.c", "w");
  fprintf(fp, "// This file was generated by volterraGenerateReuseLoop() in volterra_reuse.c\n\n");  
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterReuseLoop(smp *x, smp *y, smp *h, int P, int M, smp *xx) {\n");
  fprintf(fp, "  int i=0, m0=0");
  for (p=1; p<=P; p++) fprintf(fp, ", m%d", p);
  fprintf(fp, ";\n");
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterReuseLoop().\\n\");\n", P);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");
  fprintf(fp, "  *y = 0;\n");
  for (p=1; p<=P; p++) {
    fprintf(fp, "  for(m1=0; m1<=M; m1++) {\n");
    for (pp=2; pp<=p; pp++) {
      for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
      fprintf(fp, "for(m%d=m%d; m%d<=M; m%d++) {\n", pp, pp-1, pp, pp);
    }
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
    if (p == 1) {
      fprintf(fp, "xx[i] = x[-m1];\n");  
    } else {
      fprintf(fp, "xx[i] = xx[m0] * x[-m%d];\n", p);  
    }
    for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");    
    fprintf(fp, "*y += h[i] * xx[i++];\n");
    for (pp=p; pp>=2; pp--) {
      for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
      fprintf(fp, "}\n");
      if (pp == p) {
        for (ppp=1; ppp<=pp; ppp++) fprintf(fp, "  ");
        fprintf(fp, "m0++;\n");        
      }
    }        
    fprintf(fp, "  }\n");    
    if (p < P) fprintf(fp, "  if (P == %d) return;\n", p);
  }
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File volterra_reuse_loop.c was generated.\n");
}

void volterraGenerateReuseHard(int P, int M, int *C, int *m) {
  int i, j, p, pp;
  char filename[40];
  sprintf(filename, "volterra_reuse_hard_mem%d.c", M);
  FILE *fp = fopen(filename, "w");  
  fprintf(fp, "// This file was generated by volterraGenerateReuseHard() in volterra_reuse.c\n\n");    
  fprintf(fp, "#include <stdio.h>\n");
  fprintf(fp, "#include <stdlib.h>\n\n");
  fprintf(fp, "#include \"volterra.h\"\n\n");
  fprintf(fp, "void volterraFilterReuseHardMem%d(smp *x, smp *y, smp *h, int P, smp *xx) {\n", M);
  fprintf(fp, "  if (P > %d) {\n", P);
  fprintf(fp, "    fprintf(stderr, \"Order exceeds maximum of %d in function volterraFilterReuseHardMem%d().\\n\");\n", P, M);
  fprintf(fp, "    getchar();\n");
  fprintf(fp, "    exit(EXIT_FAILURE);\n");
  fprintf(fp, "  }\n");  
  for (i=0; i<=M; i++) {
    fprintf(fp, "  xx[%d] = x[%d];\n", i, -i);
  }
  j = 0;
  for (p=2; p<=P; p++) {
    fprintf(fp, "  if (P == %d) goto mult;\n", p-1);
    for (pp=1; pp<=p; pp++) {
      m[pp] = 0;
    }    
    start:
    fprintf(fp, "  xx[%d] = xx[%d] * x[%d];\n", i, j, -m[p]);
    i++;
    if (m[p] < M) {
      m[p]++;
      goto start;
    }
    j++;
    for (pp=p-1; pp>0; pp--) {
      if (m[pp] < M) {
        m[pp]++;
        for (pp++; pp<=p; pp++) {
          m[pp] = m[pp-1];
        }
        goto start;
      }
    }
  }
  fprintf(fp, "  mult:\n");  
  fprintf(fp, "  *y = 0;\n");
  i = 0;
  for (p=1; p<=P; p++) {
    while (i < C[p]) {
      fprintf(fp, "  *y += h[%d] * xx[%d];\n", i, i);
      i++;
    }
    if (p < P) {
      fprintf(fp, "  if (P == %d) return;\n", p);
    }    
  }
  fprintf(fp, "}\n");
  fclose(fp);
  printf("File %s was generated.\n", filename);  
}
